package edu.mit.harold.icollections;

import java.util.Collection;
import java.util.List;

/**
 * 
 * An immutable indexed collection.
 * 
 * @author harold
 *
 * @param <E>
 */
public interface ISequence<E> extends ICollection<E>, List<E> {
	
	//@Override
	public ISequence<E> plus(E e);
	
	//@Override
	public ISequence<E> plusAll(Collection<? extends E> list);
	
	/**
	 * @param i
	 * @param e
	 * @return a sequence consisting of the elements of this with e replacing the element at index i.
	 */
	public ISequence<E> with(int i, E e);
	
	/**
	 * @param i
	 * @param e non-null
	 * @return a sequence consisting of the elements of this with e inserted at index i.
	 */
	public ISequence<E> plus(int i, E e);
	
	/**
	 * @param i
	 * @param list
	 * @return a sequence consisting of the elements of this with list inserted at index i.
	 */
	public ISequence<E> plusAll(int i, Collection<? extends E> list);
	
	/**
	 * Returns a sequence consisting of the elements of this without the first occurrence of e.
	 */
	//@Override
	public ISequence<E> minus(Object e);
	
	//@Override
	public ISequence<E> minusAll(Collection<?> list);
	
	/**
	 * @param i
	 * @return a sequence consisting of the elements of this with the element at index i removed.
	 */
	public ISequence<E> minus(int i);

	//@Override
	public ISequence<E> subList(int start, int end);
}
